package com.ruoyi.oa.service;

import com.ruoyi.oa.domain.bo.SysOaWarehouseBo;
import com.ruoyi.oa.domain.vo.SysOaWarehouseMasterVo;
import com.ruoyi.oa.domain.bo.SysOaWarehouseMasterBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 出库单管理Service接口
 *
 * @author hdak
 * @date 2025-03-19
 */
public interface ISysOaWarehouseMasterService {

    /**
     * 查询出库单管理
     */
    SysOaWarehouseMasterVo queryById(Long masterId);

    /**
     * 查询出库单管理列表
     */
    TableDataInfo<SysOaWarehouseMasterVo> queryPageList(SysOaWarehouseMasterBo bo, PageQuery pageQuery);

    /**
     * 查询出库单管理列表
     */
    List<SysOaWarehouseMasterVo> queryList(SysOaWarehouseMasterBo bo);

    /**
     * 新增出库单管理
     */
    Boolean insertByBo(SysOaWarehouseMasterBo bo);

    /**
     * 修改出库单管理
     */
    Boolean updateByBo(SysOaWarehouseMasterBo bo);

    /**
     * 校验并批量删除出库单管理信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 单个入库接口
     *
     * @param bo
     * @param id
     * @return
     */
    int insertInWarehouse(SysOaWarehouseBo bo, Long id);

    /**
     * 更新采购单状态 并且将未作废的以及未完成的 taskStatus=0,1的完成入库操作
     * @param bo
     * @return
     */
    int updateMasterAndInsertBatchWare(SysOaWarehouseMasterBo bo);


    /**
     * 撤回出库
     * @param masterId
     * @return
     */
    int redoMaster(Long masterId);

}
